package tsp.csc4509.dm.rpcparam;
import java.io.Serializable;

import tsp.csc4509.dm.rpc.RpcParam;

/**
 * Classe exemple pour le RpcParam: déporte l'addition de deux entiers.
 * @author Éric Lallet.
 *
 */
public class AdditionParam implements Serializable, RpcParam {

	/**
	 * 
	 */
	private static final long serialVersionUID = 5L;
	
	/**
	 * Attribut pour mémoriser les deux entiers à additionner.
	 */
	private Integer val1;
	/**
	 * Attribut pour mémoriser les deux entiers à additionner.
	 */
	private Integer val2;
	
	/**
	 * Constructeur qui mémorise les deux entiers.
	 * @param val1
	 *            valeur du premier entier.
	 * @param val2
	 *            valeur du second entier.
	 */
	public AdditionParam(final Integer val1, final Integer val2) {
		this.val1 = val1;
		this.val2 = val2;
	}

	

	@Override
	public Class<? extends Serializable> getResultClass() {
		return Integer.class;
	}

	@Override
	public Serializable compute() {
		System.out.println("Version 1");
		return val1 + val2;
	}

}
